define({"227":{i:0.000840318598456451,u:"../Content/P4API/strbuf.constructor.html",a:"Construct a StrBuf. Notes The StrBuf constructor initializes the StrBuf\n      to contain a zero-length null buffer. Example \nint main( int argc, char **argv )\n{\n    StrBuf sb;   // constructor called\n\n    cout \u003c\u003c \"sb.Text() returns \\\"\" \u003c\u003c sb.Text() \u003c\u003c \"\\\"\\n\";\n    cout \u003c\u003c \"sb.Length() returns \" \u003c\u003c ...",t:"StrBuf::StrBuf() (Constructor)"},"228":{i:0.000840318598456451,u:"../Content/P4API/strbuf.constructor_2.html",a:"Construct a copy of a StrBuf. Notes The StrBuf copy constructor creates a copy of a\n      StrBuf. The StrBuf from which copying occurs\n      must be initialized before calling the copy constructor. The StrBuf copy constructor initializes the new\n      StrBuf to contain a zero-length null buffer, and ...",t:"StrBuf::StrBuf( const StrBuf \u0026 ) (Copy Constructor)"},"229":{i:0.000840318598456451,u:"../Content/P4API/strbuf.destructor.html",a:"Destroy a StrBuf. Notes The StrBuf destructor destroys a StrBuf. If the buffer points to allocated memory other than\n      nullStrBuf, the allocated memory is freed. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf *psb;\n    psb = ...",t:"StrBuf::~StrBuf() (Destructor)"},"230":{i:0.00990404625610068,u:"../Content/P4API/strbuf.extend.html",a:"Extend a StrBuf by one byte. The string pointed to by the\n      StrBuf\u0027s buffer is logically extended. Notes One byte is copied to the extended StrBuf. The\n      length of the StrBuf is incremented by one. Extend()  does not\n      null-terminate the extended string pointed to by the\n      StrBuf\u0027s ...",t:"StrBuf::Extend( char )"},"231":{i:0.000840318598456451,u:"../Content/P4API/strbuf.extend_2.html",a:"Extend a StrBuf by a string of a specified length. The\n      string pointed to by the StrBuf\u0027s buffer is\n      logically extended. Notes Exactly len bytes are copied from the string to the\n      extended StrBuf. The length of the\n      StrBuf is incremented by len bytes. Extend()  does not\n      ...",t:"StrBuf::Extend( const char *, int )"},"232":{i:0.00171252897065142,u:"../Content/P4API/strbuf.operator.html",a:"Assign a StrBuf from a null-terminated string. Notes Initialize the StrBuf before the assignment. The length is set to the number of bytes prior to the first\n      null byte in the string. Any memory allocated for the StrBuf\u0027s buffer\n      is separate from the memory for the string. Example ...",t:"StrBuf::operator =( const char * )"},"233":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_2.html",a:"Assign a StrBuf from another StrBuf. Notes Initialize both StrBufs before the assignment. Any memory allocated for the assigned StrBuf\u0027s\n      buffer is separate from the memory for the\n      StrBuf\u0027s buffer from which assignment\n      occurs. Do not assign a StrBuf to itself. Example \n#include ...",t:"StrBuf::operator =( const StrBuf \u0026 )"},"234":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_3.html",a:"Assign a StrBuf from a StrPtr. Notes Initialize the StrBuf and the StrPtr before\n      assignment. Any memory allocated for the StrBuf\u0027s buffer\n      is separate from the memory for the StrPtr\u0027s\n      buffer. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, ...",t:"StrBuf::operator =( const StrPtr \u0026 )"},"235":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_4.html",a:"Assign a StrBuf from a StrRef. Notes Initialize the StrBuf and StrRef before\n      assignment. Any memory allocated for the StrBuf\u0027s buffer\n      is separate from that of the StrRef\u0027s\n      buffer. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char ...",t:"StrBuf::operator =( const StrRef \u0026 )"},"236":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_5.html",a:"Append a null-terminated string to a StrBuf. The string is\n      logically appended to the string pointed to by the StrBuf\u0027s\n      buffer. Notes The StrBuf\u0027s length is incremented by the\n      number of bytes prior to the first null byte in the string. If the memory for the StrBuf\u0027s buffer is not\n   ...",t:"StrBuf::operator \u003c\u003c( const char * )"},"237":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_6.html",a:"Append a formatted integer to a StrBuf. The formatted\n      integer is logically appended to the string pointed to by the\n      StrBuf\u0027s buffer. Notes The integer is formatted with the logical equivalent of sprintf(\n\tbuf, \"%d\", v ). The length is incremented by the number of bytes of the\n      ...",t:"StrBuf::operator \u003c\u003c( int )"},"238":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_7.html",a:"Append a StrPtr to a StrBuf. The string\n      pointed to by the StrPtr\u0027s buffer is logically\n      appended to the string pointed to by the StrBuf\u0027s\n      buffer. Notes Exactly the number of bytes specified by the StrPtr\u0027s\n      length are appended to the StrBuf. The\n      StrBuf\u0027s length is ...",t:"StrBuf::operator \u003c\u003c( const StrPtr * )"},"239":{i:0.000840318598456451,u:"../Content/P4API/strbuf.operator_8.html",a:"Append a StrPtr to a StrBuf. The argument is\n      passed as a reference of the StrPtr. The string pointed to\n      by the StrPtr\u0027s buffer is logically appended to\n      the string pointed to by the StrBuf\u0027s\n      buffer. Notes Arguments are typically instances of classes derived from the\n      ...",t:"StrBuf::operator \u003c\u003c( const StrPtr \u0026 )"},"240":{i:0.00484185573369817,u:"../Content/P4API/strbuf.set.html",a:"Set a StrBuf from a null-terminated string. Notes Initialize the StrBuf before calling  Set() . The length of the StrBuf is set to the number\n      of bytes prior to the first null byte in the string. Any memory allocated for the StrBuf\u0027s buffer\n      is separate from the memory for the string. ...",t:"StrBuf::Set( const char * )"},"241":{i:0.000840318598456451,u:"../Content/P4API/strbuf.set_2.html",a:"Set a StrBuf from a string of a specified length. Notes Initialize the StrBuf before calling  Set() . Exactly len bytes are copied from the string to the\n      StrBuf. The length of the StrBuf\n      is set to the len argument. Any memory allocated for the StrBuf\u0027s buffer\n      is separate from the ...",t:"StrBuf::Set( const char *, int )"},"242":{i:0.000840318598456451,u:"../Content/P4API/strbuf.set_3.html",a:"Set a StrBuf from a pointer to a StrPtr. Notes Initialize the StrBuf and the StrPtr before\n      calling  Set() . Any memory allocated for the StrBuf\u0027s buffer\n      is separate from the memory for the StrPtr\u0027s\n      buffer. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint ...",t:"StrBuf::Set( const StrPtr * )"},"243":{i:0.000840318598456451,u:"../Content/P4API/strbuf.set_4.html",a:"Set a StrBuf from a reference of a StrPtr.\n      Arguments are commonly instances of classes derived from the\n      StrPtr class, such as StrRef and\n      StrBuf. Notes Initialize the StrBuf and the StrPtr before\n      calling  Set() . Any memory allocated for the StrBuf\u0027s buffer\n      is separate ...",t:"StrBuf::Set( const StrPtr \u0026 )"},"244":{i:0.00718220285685661,u:"../Content/P4API/strbuf.stringinit.html",a:"Initialize a StrBuf. Notes StringInit() \n      initializes the StrBuf to contain a zero-length null\n      buffer. Normally when a StrBuf is created, it is initialized using\n      the StrBuf constructor. However, there may be specialized\n      cases where memory has already been allocated for a ...",t:"StrBuf::StringInit()"},"245":{i:0.019303035089148,u:"../Content/P4API/strbuf.terminate.html",a:"Null-terminate the string pointed to by the buffer member\n      of a StrBuf. The null byte is placed in the buffer at the\n      location indicated by the length member. Notes Initialize the StrBuf before calling  Terminate() . The length member of the StrBuf is effectively\n      unchanged by  ...",t:"StrBuf::Terminate()"},"246":{i:0.000840318598456451,u:"../Content/P4API/strdict.html",a:"StrDict methods This section lists the available StrDict methods.",t:"StrDict methods"},"247":{i:0.00333464134168486,u:"../Content/P4API/strdict.getvar.html",a:"Return the value of the specified variable, or  NULL\n      if not defined. Notes For the most part, all of the following methods are equivalent: StrDict::GetVar( const StrPtr \u0026 ) StrDict::GetVar( const char * ) StrDict::GetVar( const char *, Error * ) StrDict::GetVar( const StrPtr \u0026, int ) ...",t:"StrDict::GetVar( const StrPtr \u0026 )"},"248":{i:0.000840318598456451,u:"../Content/P4API/strdict.getvar_2.html",a:"StrDict::GetVar( const char * ) Return the value of the specified variable, or  NULL\n      if not defined. Notes For the most part, all of the  GetVar()  methods are\n      equivalent. For details, see  StrDict::GetVar(\n\t  const StrPtr \u0026 )",t:"StrDict::GetVar( const char * )"},"249":{i:0.000840318598456451,u:"../Content/P4API/strdict.getvar_3.html",a:"StrDict::GetVar( const char *, Error * ) Return the value of the specified variable, or  NULL\n      if not defined. Notes For the most part, all of the  GetVar()  methods are\n      equivalent. For details, see  StrDict::GetVar(\n\t  const StrPtr \u0026 )",t:"StrDict::GetVar( const char *, Error * )"},"250":{i:0.000840318598456451,u:"../Content/P4API/strdict.getvar_4.html",a:"StrDict::GetVar( const StrPtr \u0026, int ) Return the value of the specified variable, or  NULL\n      if not defined. Notes For the most part, all of the  GetVar()  methods are\n      equivalent. For details, see  StrDict::GetVar(\n\t  const StrPtr \u0026 )",t:"StrDict::GetVar( const StrPtr \u0026, int )"},"251":{i:0.000840318598456451,u:"../Content/P4API/strdict.getvar_5.html",a:"StrDict::GetVar( const StrPtr \u0026, int, int ) Return the value of the specified variable, or  NULL\n      if not defined. Notes For the most part, all of the  GetVar()  methods are\n      equivalent. For details, see  StrDict::GetVar(\n\t  const StrPtr \u0026 )",t:"StrDict::GetVar( const StrPtr \u0026, int, int )"},"252":{i:0.000840318598456451,u:"../Content/P4API/strdict.getvar_6.html",a:"Return the value of the specified variable, or  NULL\n      if not defined. Notes This method is typically used when iterating through a\n      StrDict. For the most part, all of the  GetVar()  methods are\n      equivalent. For details, see  StrDict::GetVar(\n\t  const StrPtr \u0026 )",t:"StrDict::GetVar( int, StrPtr \u0026, StrPtr \u0026 )"},"253":{i:0.00193924293655571,u:"../Content/P4API/strdict.load.html",a:"Unmarshals the StrDict from a file. Notes Load()  loads a\n      StrDict from a file previously created by  Save() . Example The following example \"loads\" a StrDict by reading it from\n      stdin. \nMyStrDict sd;\nClientUser ui;\n\nsd.Load( stdin );\nui.OutputStat( \u0026sd ); Given a marshaled StrDict on ...",t:"StrDict::Load( FILE * )"},"254":{i:0.00193924293655571,u:"../Content/P4API/strdict.save.html",a:"Marshals the StrDict into a text file. Notes Save()  stores the\n      StrDict in a marshaled form to a text file, which can be\n      recovered by using  Load() . Example The following example \"saves\" a StrDict by writing it to\n      stdout. \nvoid MyClientUser::OutputStat( StrDict *varList )\n{\n    ...",t:"StrDict::Save( FILE * )"},"255":{i:0.0192459700864035,u:"../Content/P4API/strdict.setargv.html",a:"Set a list of values, such as the arguments to a\n      Helix server\n      command. Notes SetArgv()  is typically\n      used when setting command arguments in ClientApi. Example p4api.cc provides an example of using  SetArgv()  to set\n      arguments. \nint main( int argc, char **argv )\n{\n    ...",t:"StrDict::SetArgv( int, char *const * )"},"256":{i:0.000840318598456451,u:"../Content/P4API/strnum.html",a:"StrNum methods This section lists the available StrNum methods.",t:"StrNum methods"},"257":{i:0.00146144027130744,u:"../Content/P4API/strnum.strnum.html",a:"Create a StrNum, either unset or with a value. Notes A StrNum always stores numbers using base ten. To create a StrNum without a value, call  StrNum()  without an\n      argument. Example The following example creates a StrNum and displays it: \n#include \u003ciostream\u003e\n#include \u003cstdhdrs.h\u003e\n#include ...",t:"StrNum::StrNum( int ) (constructor)"},"258":{i:0.000840318598456451,u:"../Content/P4API/strnum.set.html",a:"Set a StrNum\u0027s value. Notes A StrNum always stores numbers using base ten. Example \n#include \u003ciostream\u003e\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrNum sn;\n    sn.Set ( 1666 );\n    cout \u003c\u003c \"sn.Text() returns \\\"\" \u003c\u003c sn.Text() \u003c\u003c \"\\\"\\n\";\n} Executing the ...",t:"StrNum::Set( int )"},"259":{i:0.000840318598456451,u:"../Content/P4API/strops.html",a:"StrOps methods This section lists the available StrOps methods.",t:"StrOps methods"},"260":{i:0.000840318598456451,u:"../Content/P4API/strops.caps.html",a:"Convert the first character in a string (in place) to uppercase. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n#include \u003cstrops.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf sb;\n\n    sb.Set( \"xyzzy\" );\n    printf( \"Before: %s\\n\", sb.Text() );\n\n    StrOps::Caps( sb );\n    printf( \"After: ...",t:"StrOps::Caps( StrBuf \u0026 )"},"261":{i:0.000840318598456451,u:"../Content/P4API/strops.dump.html",a:"Pretty-print a string to stdout Notes Unprintable characters are displayed as hexadecimal ASCII values,\n      surrounded by greater-than/less-than characters. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n#include \u003cstrops.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf sb;\n    sb.Set( ...",t:"StrOps::Dump( const StrPtr \u0026 )"},"262":{i:0.00148895099380583,u:"../Content/P4API/strops.expand.html",a:"Expand “`%var%” strings into corresponding\n\t“`val” strings from a StrDict. Notes This function provides a way to quickly expand variables from a\n      StrDict into a StrBuf. Example This small program demonstrates the  Expand()  method in an  OutputStat() \n      implementation: \nvoid ...",t:"StrOps::Expand( StrBuf \u0026, StrPtr \u0026, StrDict \u0026 )"},"263":{i:0.00106707521147722,u:"../Content/P4API/strops.expand2.html",a:"Expand “[%var%|alt\\]” strings into corresponding\n      “val” strings from a StrDict, or “alt” if\n      “var” is undefined. Notes Like  Expand() , this\n      function provides a way to quickly expand variables from a\n      StrDict into a StrBuf, with the additional\n      feature of providing ...",t:"StrOps::Expand2( StrBuf \u0026, StrPtr \u0026, StrDict \u0026 )"},"264":{i:0.000840318598456451,u:"../Content/P4API/strops.indent.html",a:"Make a copy of a string, with each line indented. Notes This function reads the input string s and copies it to the\n      output string o, with each line indented with a single\n      tab. Example \nStrBuf s = StrBuf();\ns.Set( \"abc\\ndef\\nghi\\n\" );\n\nStrBuf o = StrBuf();\nStrOps::Indent( o, s );\n\nprintf( ...",t:"StrOps::Indent( StrBuf \u0026, const StrPtr \u0026 )"},"265":{i:0.000840318598456451,u:"../Content/P4API/_strops_lines_strbuf_char_int.html",a:"Break a string apart at line breaks. Notes This function handles all types of line breaks: “\\r”, “\\n”, and\n      “\\r\\n”. Example \nStrBuf o = StrBuf();\no.Set( \"abc\\ndef\\nghi\\n\" );\n\nprintf( \"Input StrBuf:\\n%s\\n\", o.Text() );\n\nchar *vec[4];\nint l = StrOps::Lines( o, vec, 4 );\n\nfor ( ; l ; l-- )\n{\n    ...",t:"StrOps::Lines( StrBuf \u0026, char *[], int )"},"266":{i:0.000840318598456451,u:"../Content/P4API/strops.lower.html",a:"Convert each character in a string (in place) to lowercase Notes This function modifies an original string in place by converting all\n      uppercase characters to lowercase. Example \nStrBuf o = StrBuf();\no.Set( \"xYzZy\" );\n\nprintf( \"Before: %s\\n\", o );\nStrOps::Lower( o );\nprintf( \"After:  %s\\n\", o ...",t:"StrOps::Lower( StrBuf \u0026 )"},"267":{i:0.000840318598456451,u:"../Content/P4API/strops.otox.html",a:"Convert an octet stream into hex. Notes This function converts the input stream into a string of hexadecimal\n      numbers, with each byte from the input being represented as exactly two\n      hex digits. Example \nconst unsigned char stream[3] = { \u0027f\u0027, \u0027o\u0027, \u0027o\u0027 };\nStrBuf hex;\nStrOps::OtoX( stream, ...",t:"StrOps::OtoX( const unsigned char *, int, StrBuf \u0026 )"},"268":{i:0.000840318598456451,u:"../Content/P4API/strops.replace.html",a:"Replace substrings in a StrPtr and store the result to a\n      StrBuf. Notes This function reads the input string i and copies it to the\n      output string o, after replacing each occurrence of the\n      string s with string r. Example \nStrBuf i = StrBuf();\ni.Set( \"PerForce is PerForce, of course, ...",t:"StrOps::Replace( StrBuf \u0026, const StrPtr \u0026, const StrPtr \u0026, const StrPtr \u0026 )"},"269":{i:0.000840318598456451,u:"../Content/P4API/strops.sub.html",a:"Substitute instances of one character for another. Notes This function substitutes the replace character for every\n      instance of the target character in the input\n      string. The substitution is performed in place. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n#include \u003cstrops.h\u003e\n\nint ...",t:"StrOps::Sub( StrPtr \u0026, char, char )"},"270":{i:0.000840318598456451,u:"../Content/P4API/strops.upper.html",a:"Convert each character in a string (in place) to uppercase Notes This function modifies an original string in place by converting all\n      lowercase characters to uppercase. Example \nStrBuf o = StrBuf();\no.Set( \"xYzZy\" );\n\nprintf( \"Before: %s\\n\", o );\nStrOps::Upper( o );\nprintf( \"After:  %s\\n\", o ...",t:"StrOps::Upper( StrBuf \u0026 )"},"271":{i:0.000840318598456451,u:"../Content/P4API/strops.words.html",a:"Break a string apart at whitespace. Notes This function uses the isAspace() function to define\n      whitespace. Example \nStrBuf o = StrBuf();\nStrBuf tmp = StrBuf();\no.Set( \"abc\\tdef   ghi\\nxyz xyzzy plugh\" );\n\nprintf( \"Input StrBuf:\\n%s\\n\", o.Text() );\n\nchar *vec[5];\nint w = StrOps::Words( tmp, o, ...",t:"StrOps::Words( StrBuf \u0026, const char *[], char *[], int )"},"272":{i:0.000840318598456451,u:"../Content/P4API/strops.xtoo.html",a:"Convert a hex string into an octet stream. Notes This function converts the input hexadecimal string into the stream of\n      bytes that it represents. Example \nchar *hex = \"666F6F\";\nunsigned char oct[4];\n\nStrOps::XtoO( hex, oct, 3 );\noct[3] = \u0027\\0\u0027;\n\nprintf( \"%s\", oct );\n\nreturn 0; Executing the ...",t:"StrOps::XtoO( char *, unsigned char *, int )"},"273":{i:0.000840318598456451,u:"../Content/P4API/strptr.html",a:"StrPtr methods This section lists the available StrPtr methods.",t:"StrPtr methods"},"274":{i:0.00117254415705937,u:"../Content/P4API/strptr.atoi.html",a:"Return the numeric value, if any, represented by this\n      StrPtr\u0027s buffer. Notes StrPtr::Atoi()  is equivalent\n      to calling atoi( StrPtr::Text() ).\n      Non-numeric strings typically return a value of zero. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv ...",t:"StrPtr::Atoi()"},"275":{i:0.00231821189237942,u:"../Content/P4API/strptr.ccompare.html",a:"Case insensitive comparison of two StrPtrs. Notes StrPtr::CCompare()  is a\n      wrapper for stricmp() or strcasecmp(). Its\n      return value, if nonzero, indicates which of the two strings is \"greater\"\n      in the ASCII sense. See also StrPtr::XCompare() StrPtr::Compare() Example \n#include ...",t:"StrPtr::CCompare( const StrPtr \u0026 )"},"276":{i:0.00231821189237942,u:"../Content/P4API/strptr.compare.html",a:"Comparison of two StrPtrs, with case sensitivity based on\n      client platform. Notes StrPtr::Compare()  is a\n      wrapper for zstrcmp(). Its return value, if nonzero,\n      indicates which of the two strings is \"greater\" in the ASCII sense. See also StrPtr::CCompare() StrPtr::XCompare() . Example ...",t:"StrPtr::Compare( const StrPtr \u0026 )"},"277":{i:0.00146144027130744,u:"../Content/P4API/strptr.contains.html",a:"Look for a substring and, if found, return it. Notes StrPtr::Contains() \n      returns a pointer to the StrPtr’s buffer, rather than\n      allocating a new buffer for the substring. If it cannot find the\n      substring,  Contains() \n      returns  NULL. Example \n#include \u003cstdhdrs.h\u003e\n#include ...",t:"StrPtr::Contains( const StrPtr \u0026 )"},"278":{i:0.000840318598456451,u:"../Content/P4API/strptr.length.html",a:"Return the length of this StrPtr. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"This string\" );\n\n    printf( \"%s is %d bytes long\\n\", str1, str1.Length() );\n    return 0;\n} Executing the preceding code produces the following ...",t:"StrPtr::Length()"},"279":{i:0.000840318598456451,u:"../Content/P4API/strptr.operator.html",a:"Return the character at the specified index. Notes This operator does no bounds checking, and can therefore return data\n      from beyond the end of the string. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"the quick brown fox ...",t:"StrPtr::operator []( int )"},"280":{i:0.000840318598456451,u:"../Content/P4API/strptr.operators_1.html",a:"Case-sensitive comparison operators between StrPtr and\n      char *. Notes These operators are typically used in simple comparisons between\n      StrPtrs, such as to see whether two StrPtrs\n      contain the same string, or whether one is greater than the other,\n      ASCII-wise. The comparison is ...",t:"StrPtr::operators ==, !=, \u003e, \u003c, \u003c=, \u003e= ( const char * )"},"281":{i:0.000840318598456451,u:"../Content/P4API/strptr.operators_2.html",a:"Case-sensitive comparison operators between StrPtr and\n      StrPtr. Notes These operators are typically used in simple comparisons between\n      StrPtrs, such as to see whether two StrPtrs\n      contain the same string, or whether one is greater than the other,\n      ASCII-wise. The comparison is ...",t:"StrPtr::operators ==, !=, \u003e, \u003c, \u003c=, \u003e= ( const StrPtr \u0026 )"},"282":{i:0.0124446356664712,u:"../Content/P4API/strptr.text.html",a:"Return the char * containing this StrPtr\u0027s\n      text. Notes StrPtr::Text()  and  StrPtr::Value()  are exactly\n      equivalent. Their most typical use is converting a StrPtr to\n      a char * for functions outside of the client API to use. Example \n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint ...",t:"StrPtr::Text()"},"283":{i:0.00609312137755976,u:"../Content/P4API/strptr.value.html",a:"Return the char * containing this StrPtr\u0027s\n      text. Notes StrPtr::Value()  is the\n      deprecated form of  StrPtr::Text() . The two\n      functions are equivalent. Their most typical use is converting a\n      StrPtr to a char * for functions outside of the\n      client API to use. Example ...",t:"StrPtr::Value()"},"284":{i:0.00231821189237942,u:"../Content/P4API/strptr.xcompare.html",a:"Case sensitive comparison of two StrPtrs. Notes StrPtr::XCompare()  is a\n      wrapper for strcmp(). Its return value, if nonzero,\n      indicates which of the two strings is \"greater\" in the ASCII sense. See also StrPtr::CCompare() StrPtr::Compare() Example \n#include \u003cstdhdrs.h\u003e\n#include ...",t:"StrPtr::XCompare( const StrPtr \u0026 )"},"285":{i:0.000840318598456451,u:"../Content/P4API/strref.html",a:"StrRef methods This section lists the available StrRef methods.",t:"StrRef methods"},"286":{i:0.000840318598456451,u:"../Content/P4API/strref.constructor.html",a:"StrRef::StrRef() (constructor) Construct a StrRef, and leave it unset. Notes If arguments are provided, the constructor calls  Set()  with them.",t:"StrRef::StrRef() (constructor)"},"287":{i:0.000840318598456451,u:"../Content/P4API/strref.constructor_2.html",a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"abc\" );\n    StrRef sr = StrRef( ...",t:"StrRef::StrRef( const StrPtr \u0026 ) (constructor)"},"288":{i:0.000840318598456451,u:"../Content/P4API/strref.constructor_3.html",a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    char chars[] = \"abc\";\n    StrRef sr = StrRef( chars );\n\n    ...",t:"StrRef::StrRef( const char * ) (constructor)"},"289":{i:0.000840318598456451,u:"../Content/P4API/strref.constructor_4.html",a:"Construct a StrRef, referencing an existing string. Notes If arguments are provided, the constructor calls  Set()  with them. StrRef::Set()  does not copy\n      the target string; it simply creates a pointer to it. Be sure that the\n      StrRef pointing to the target string does not outlive the\n     ...",t:"StrRef::StrRef( const char * , int ) (constructor)"},"290":{i:0.00297849071514519,u:"../Content/P4API/strref.null.html",a:"Return a null StrPtr. Notes StrRef::Null()  is a static\n      function. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"abc\" );\n    StrRef sr = StrRef( str1 );\n\n    if ( sr == StrRef::Null() )\n        cout ...",t:"StrRef::Null()"},"291":{i:0.000840318598456451,u:"../Content/P4API/strref.operator.html",a:"Set a StrPtr to reference an existing StrPtr\n      or null-terminated string. Notes The = operator is equivalent to calling  Set() . Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    StrBuf str1;\n\n    str1.Set( \"xyz\" );\n    StrRef sr = ...",t:"StrRef::operator =( StrPtr \u0026 )"},"292":{i:0.000840318598456451,u:"../Content/P4API/strref.operator_2.html",a:"Set a StrPtr to reference an existing StrPtr\n      or null-terminated string. Notes The = operator is equivalent to calling  Set() . Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include \u003cstrbuf.h\u003e\n\nint main( int argc, char **argv )\n{\n    char chars[] = \"xyz\";\n    StrRef sr;\n\n    sr = chars;\n\n ...",t:"StrRef::operator =( char * )"},"293":{i:0.000840318598456451,u:"../Content/P4API/strref.operator_3.html",a:"Increase a StrRef’s pointer and decrease its length. Notes This method has the effect of removing len characters from\n      the beginning of the StrRef. It does not, however, free the\n      memory allocated to those characters. Example \n#include \u003ciostream\u003e\n\n#include \u003cstdhdrs.h\u003e\n#include ...",t:"StrRef::operator +=( int )"},"294":{i:0.00705153532696638,u:"../Content/P4API/strref.set.html",a:"Set a StrRef to reference an existing null-terminated\n      string. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include ...",t:"StrRef::Set( char * )"},"295":{i:0.000840318598456451,u:"../Content/P4API/strref.set_2.html",a:"Set a StrRef to reference an existing null-terminated\n      string. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include ...",t:"StrRef::Set( char * , int )"},"296":{i:0.000840318598456451,u:"../Content/P4API/strref.set_3.html",a:"Set a StrRef to reference an existing\n      StrPtr. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include \u003ciostream\u003e\n\n#include ...",t:"StrRef::Set( const StrPtr * )"},"297":{i:0.000840318598456451,u:"../Content/P4API/strref.set_4.html",a:"Set a StrRef to reference an existing\n      StrPtr. Notes StrRef::Set()  does not copy\n      the target string; it simply establishes a pointer to it. Be sure that\n      the StrRef pointing to the target string does not outlive\n      the target string. Example \n#include \u003ciostream\u003e\n\n#include ...",t:"StrRef::Set( const StrPtr \u0026 )"},"298":{i:0.000840318598456451,u:"../Content/Shared/glossary.html",a:"Glossary",t:"Glossary"},"299":{i:0.000840318598456451,u:"../Content/P4API/license.statements.html",a:"To get a listing of the third-party software licenses that Helix Core server uses, at the command line, type the p4 help legal command. To get a listing of the third-party software licenses that the local client (such as P4V) uses, at the command line, type the p4 help -l legal command.",t:"License Statements"},});